#ifndef DIALOG_H
#define DIALOG_H

#include <QDialog>
#include <webautologin.h>

namespace Ui {
  class Dialog;
}

class Dialog : public QDialog, public VXMLable
{
  Q_OBJECT

public:
  friend class WebAutoLogin;

public:
  explicit Dialog(QWidget *parent = 0);
  ~Dialog();

public:
  virtual void load(VXML xml);
  virtual void save(VXML xml);

public:
  int           lastProgress;
  int           loadingCount;
  WebAutoLogin* wal;
  
private slots:
  void on_btnGo_clicked();

  void on_webView_iconChanged();

  void on_webView_linkClicked(const QUrl &arg1);

  void on_webView_loadFinished(bool arg1);

  void on_webView_loadProgress(int progress);

  void on_webView_loadStarted();

  void on_webView_selectionChanged();

  void on_webView_statusBarMessage(const QString &text);

  void on_webView_titleChanged(const QString &title);

  void on_webView_urlChanged(const QUrl &arg1);

  void on_webView_customContextMenuRequested(const QPoint &pos);

private:
  Ui::Dialog *ui;
};

#endif // DIALOG_H
