#ifndef __WEB_AUTO_LOGIN_H__
#define __WEB_AUTO_LOGIN_H__

#include <QWebView>
#include <QWebPage>
#include <QWebFrame>
#include <QWebElement>
#include <QMouseEvent>
#include <QKeyEvent>

#include <VDream/Common/VXMLDoc.h>
#include <VDream/Common/VApp.h>
#include <VDream/Common/VThread.h>
#include <VDream/Log/VLog.h>
#include <VDream/Common/VSystem.h>

// ----------------------------------------------------------------------------
// WebAutoLogin
// ----------------------------------------------------------------------------
class Dialog;
class WebAutoLogin : public QObject, public VXMLable, public VRunnable
{
  Q_OBJECT

protected:
  Dialog* m_dialog;

public:
  WebAutoLogin(Dialog* dialog);
  virtual ~WebAutoLogin();

public:
  QString     url;
  QString     id;
  QString     pw;
  VDuration   waitInterval;
  VDuration   pageInterval;
  QStringList acceptIDTagNames;
  QStringList acceptIDAttributeNames;
  QStringList acceptIDAttributeValues;

public:
  virtual void load(VXML xml);
  virtual void save(VXML xml);

public:
  VEvent webViewEvent;
  VEvent waitEvent;
  bool waitSleep();

public:
  virtual void run();

signals:
  bool        _go(QString url);
  bool        _clickElement(QWebElement* element);
  bool        _setAttribute(QWebElement* element, QString value);
  bool        _pressEnterElement(QWebElement* element);
  bool        _applicationTerminate();

public slots:
  bool        go(QString url);
  bool        findIDAndPWElement(QWebElement& idElement, QWebElement& pwElement);
  QWebElement findPWElement(QWebElement element);
  QWebElement findIDElement(QWebElement element, int depth);
  QWebElement findLoginElement();
  bool        clickElement(QWebElement* element);
  bool        setAttribute(QWebElement* element, QString value);
  bool        pressEnterElement(QWebElement* element);
  bool        applicationTerminate();
};

#endif // __WEB_AUTO_LOGIN_H__
